/*
 * $Id$
 *
 * [ Description ]
 * 
 */

#include "Behavioural/Generic/Select/Select_Priority_Fixed/include/Parameters.h"

namespace morpheo {
namespace behavioural {
namespace generic {
namespace select {
namespace select_priority_fixed {


  Parameters::Parameters (uint32_t nb_entity       ,
			  bool     encoding_one_hot,
			  bool     encoding_compact):
    _nb_entity        (nb_entity       ),
    _encoding_one_hot (encoding_one_hot),
    _encoding_compact (encoding_compact),
    _size_entity (static_cast<uint32_t> (ceil(log2(nb_entity))))
  {
    log_printf(FUNC,Select_Priority_Fixed,"Parameters","Begin");
    test();
    log_printf(FUNC,Select_Priority_Fixed,"Parameters","End");
  };
  
  Parameters::Parameters (Parameters & param):
    _nb_entity        (param._nb_entity       ),
    _encoding_one_hot (param._encoding_one_hot),
    _encoding_compact (param._encoding_compact),
    _size_entity      (param._size_entity     )
  {
    log_printf(FUNC,Select_Priority_Fixed,"Parameters","Begin");
    test();
    log_printf(FUNC,Select_Priority_Fixed,"Parameters","End");
  };

  Parameters::~Parameters () 
  {
    log_printf(FUNC,Select_Priority_Fixed,"~Parameters","Begin");
    log_printf(FUNC,Select_Priority_Fixed,"~Parameters","End");
  };

}; // end namespace select_priority_fixed
}; // end namespace select
}; // end namespace generic

}; // end namespace behavioural
}; // end namespace morpheo              
